public class TickerTapeComp extends ComponentApp {
   int Speed;
   int Frame;
   int Background;
   int LED;
   int numImages;
   int MaxImages;
   DAssetManager assetMan;
   DDrawJava theJavaApplet;
   String[] imageNames;
   int[] imageURLs;

   public String PropertyListener(String var1, String var2, int var3, int var4, IDInspector var5) {
      if (var3 == 1) {
         if (var1.compareTo("Number of Messages") == 0) {
            return Integer.toString(this.numImages);
         }

         if (var1.compareTo("Speed") == 0) {
            return Integer.toString(this.Speed);
         }

         if (var1.compareTo("Frame Color") == 0) {
            return Integer.toString(this.Frame);
         }

         if (var1.compareTo("Background Color") == 0) {
            return Integer.toString(this.Background);
         }

         if (var1.compareTo("LED Color") == 0) {
            return Integer.toString(this.LED);
         }

         for(int var6 = 0; var6 < this.numImages; ++var6) {
            if (var1.compareTo("Text for Message " + Integer.toString(var6 + 1)) == 0) {
               return new String(this.imageNames[var6]);
            }

            if (var1.compareTo("URL for Message " + Integer.toString(var6 + 1)) == 0) {
               return Integer.toString(this.imageURLs[var6]);
            }
         }
      } else if (var1.compareTo("Number of Messages") == 0) {
         this.numImages = Integer.parseInt(var2, 10);
         if (this.numImages > this.MaxImages) {
            this.numImages = this.MaxImages;
         }
      } else if (var1.compareTo("Speed") == 0) {
         this.Speed = Integer.parseInt(var2, 10);
         if (this.Speed < 1) {
            this.Speed = 1;
         } else if (this.Speed > 50) {
            this.Speed = 50;
         }

         this.theJavaApplet.AddParam("speed", "int\u0000", Integer.toString(this.Speed));
      } else if (var1.compareTo("Frame Color") == 0) {
         this.Frame = Integer.parseInt(var2, 10);
         this.SetColor("framecolor", this.Frame);
      } else if (var1.compareTo("Background Color") == 0) {
         this.Background = Integer.parseInt(var2, 10);
         this.SetColor("backcolor", this.Background);
      } else if (var1.compareTo("LED Color") == 0) {
         this.LED = Integer.parseInt(var2, 10);
         this.SetColor("ledcolor", this.LED);
      } else {
         for(int var9 = 0; var9 < this.numImages; ++var9) {
            if (var1.compareTo("Text for Message " + Integer.toString(var9 + 1)) == 0) {
               this.imageNames[var9] = var2;
               this.theJavaApplet.AddParam("text" + Integer.toString(var9 + 1), "String\u0000", var2);
            }

            if (var1.compareTo("URL for Message " + Integer.toString(var9 + 1)) == 0) {
               this.imageURLs[var9] = Integer.parseInt(var2, 10);
               String var7;
               if (this.imageURLs[var9] != -1) {
                  var7 = this.assetMan.GetAssetLocation(this.imageURLs[var9], 0, 1);
               } else {
                  var7 = "";
               }

               this.theJavaApplet.AddParam("link" + Integer.toString(var9 + 1), "String\u0000", var7);
            }
         }
      }

      return "";
   }

   public void onCopy() {
      String[] var1 = this.imageNames;
      int[] var2 = this.imageURLs;
      this.allocateImageArray(this.MaxImages);

      for(int var3 = 0; var3 < this.numImages; ++var3) {
         this.imageNames[var3] = new String(var1[var3]);
         if (var2[var3] != 0 && var2[var3] != -1) {
            this.imageURLs[var3] = var2[var3];
            this.assetMan.CopyAsset(var2[var3]);
         }
      }

   }

   public String onInstall(DAssetManager var1, String var2) {
      this.MaxImages = 50;
      this.assetMan = var1;
      return "Ticker Tape";
   }

   protected void finalize() {
      for(int var1 = 0; var1 < this.numImages; ++var1) {
         if (this.imageURLs[var1] != 0 && this.imageURLs[var1] != -1) {
            this.assetMan.RemoveAsset(this.imageURLs[var1]);
         }
      }

   }

   public void onUnInstall(DAssetManager var1) {
   }

   public void onPublish(DAssetManager var1, int var2) {
   }

   private void SetColor(String var1, int var2) {
      if (var2 == 0) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "black");
      } else if (var2 == 1) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "blue");
      } else if (var2 == 2) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "cyan");
      } else if (var2 == 3) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "darkGray");
      } else if (var2 == 4) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "gray");
      } else if (var2 == 5) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "green");
      } else if (var2 == 6) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "lightGray");
      } else if (var2 == 7) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "magenta");
      } else if (var2 == 8) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "orange");
      } else if (var2 == 9) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "pink");
      } else if (var2 == 10) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "red");
      } else if (var2 == 11) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "white");
      } else if (var2 == 12) {
         this.theJavaApplet.AddParam(var1, "String\u0000", "yellow");
      }

   }

   public void onDrop(IDLayout var1, IDRect var2, int var3) {
      if (var3 == 1) {
         this.numImages = 2;
         this.Speed = 25;
         this.Frame = 6;
         this.Background = 0;
         this.LED = 5;
         this.allocateImageArray(this.MaxImages);
         this.theJavaApplet = new DDrawJava();
         this.theJavaApplet.setImageFile(this.theJavaApplet.getCodeBase() + "TickerTape.jpg");
         this.theJavaApplet.setStretch(2);
         this.theJavaApplet.setAppletFileName(this.theJavaApplet.getCodeBase() + "TickerTape.class");
         this.theJavaApplet.SetPositionRect(var2.getLeft(), var2.getTop(), var2.getRight(), var2.getBottom());
         var1.AddObject(this.theJavaApplet);
      }
   }

   void allocateImageArray(int var1) {
      this.imageNames = new String[var1];
      this.imageURLs = new int[var1];

      for(int var2 = 0; var2 < var1; ++var2) {
         this.imageURLs[var2] = -1;
         this.imageNames[var2] = "";
      }

   }

   public void onInspect(CStringArray var1, CStringArray var2) {
      var1.Set("Number of Messages");
      var2.Set("Collection\u0000");

      for(int var3 = 0; var3 < this.numImages; ++var3) {
         var1.Set("Text for Message " + Integer.toString(var3 + 1));
         var2.Set("String\u0000");
         var1.Set("URL for Message " + Integer.toString(var3 + 1));
         var2.Set("Link\u0000");
      }

      var1.Set("Speed");
      var2.Set("Collection\u0000");
      var1.Set("Frame Color");
      var2.Set("Set(black|blue|cyan|darkGray|gray|green|lightGray|magenta|orange|pink|red|white|yellow)\u0000");
      var1.Set("Background Color");
      var2.Set("Set(black|blue|cyan|darkGray|gray|green|lightGray|magenta|orange|pink|red|white|yellow)\u0000");
      var1.Set("LED Color");
      var2.Set("Set(black|blue|cyan|darkGray|gray|green|lightGray|magenta|orange|pink|red|white|yellow)\u0000");
   }
}
